#pragma once

#include "messagebasic.h"


// пӻϢ =======================================================
/// <summary>
/// ȡϸ
/// </summary>
struct MESSAGEBASIC_EXPORT Get3DBox : public AbstractMessage {
	Get3DBox();
	std::shared_ptr<Serializable> newDefault() const override;
};

/// <summary>
/// ̬ݽṹ
/// </summary>
struct Posture {
	double _azimuth_deg = 0;
	double _pitch_deg = 0;
	double _roll_deg = 0;
};
/// <summary>
/// άݽṹ
/// </summary>
struct VolumeData {
	double _length_m = 0;
	double _width_m = 0;
	double _height_m = 0;
};

/// <summary>
/// ϸݶ
/// </summary>
struct MESSAGEBASIC_EXPORT Box3DDesc : public AbstractMessage {
	VolumeData _d3_data;
	Posture _posture_d3;
	LonLatAlt _lla_pos;

	Box3DDesc();

	// ͨ WsMessage ̳
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ά
/// </summary>
struct MESSAGEBASIC_EXPORT Set3DBoxD3Data : public AbstractMessage {
	VolumeData _d3_data;

	Set3DBoxD3Data();

	// ͨ WsMessage ̳
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ̬
/// </summary>
struct MESSAGEBASIC_EXPORT Set3DBoxPosture : public AbstractMessage
{
	Posture _posture_d3;

	Set3DBoxPosture();

	// ͨ WsMessage ̳
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// õλ
/// </summary>
struct MESSAGEBASIC_EXPORT Set3DBoxLLAPos : public AbstractMessage
{
	LonLatAlt _lla_pos;

	Set3DBoxLLAPos();

	// ͨ WsMessage ̳
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};
